(* Lottozahlen 
 *
 * Es ist zwar bisher mit Computern nicht mglich, die Lottozahlen vorher zu sagen, 
 * aber man kann so tun als ob. Das kann auch sehr unterhaltsam sein. Das Programm 
 * bildet den Ziehungsmechanismus weitestgehend nach, indem ein Feld definiert wird, 
 * bei dem die Indices die Nummer der Kugeln darstellen und der Inhalt jedes einzelnen 
 * Feldelements die Information, ob die Kugel schon gezogen wurde. 
 *)

PROGRAM lotto; 

  TYPE zustand = (gezogen,nicht_gezogen); 

  VAR kugel       : ARRAY [1..49] OF zustand; 
      index, 
      nummer      : integer; 
      vorhanden   : boolean; 

BEGIN 
  (*** Initialisierung des Feldes "kugel" ***) 
    FOR index := 1 TO 49 DO 
      kugel [index] := nicht_gezogen; 
  (*** Ziehungsvorgang ***) 
    FOR index := 1 TO 6 DO 
    BEGIN 
      REPEAT 
        nummer := random (49) + 1; 
        vorhanden := (kugel [nummer] = nicht_gezogen); 
      UNTIL vorhanden; 
      kugel [nummer] := gezogen; 
    END; 

  (*** Ausgabe der gezogenen Nummern ***) 
    FOR index := 1 TO 49 DO 
    BEGIN 
      IF (kugel [index] = gezogen) THEN 
        write (index:5); 
    END; 

  writeln; 
END. 
