(* Buchstabenstatistik 
 * 
 * Ein wichtiges Hilfsmittel in der Wissenschaft ist die Identifizierung von Autoren. 
 * Angefangen von Literatur- und Musikwissenschaften bis hin zur Kriminalistik versucht 
 * man, unbekannte Stcke (Gedichte, Romane, Musikstcke, Briefe) bekannten Autoren 
 * zuzuordnen. Die Grundlage ist die statistische Auszhlung nach bestimmten Kriterien, 
 * zum Beispiel bei Texten nach Buchstaben. Das folgende Programm erstellt eine 
 * Buchstabenhufigkeitsstatistik einer vorbereiteten Textdatei. Bercksichtigt werden 
 * nur die Zeichen der 7- Bit-ASCII Norm (Amerikanischer Zeichensatz). Als Zusatz wird 
 * eine Fehlerbehandlung durch die Funktion "search" eingefhrt. Sie sollte in keiner
 * PASCAL- Unterprogrammbibliothek fehlen. 
 *)

PROGRAM stat; 

  TYPE str = STRING; 
       count = ARRAY [' '..'~'] OF integer; 

  VAR letter   : count; 
      infile   : text; 
      filename : STRING; 
      found    : boolean; 
      c,index  : char; 

FUNCTION search (VAR _file : text; _name : str) : boolean; 
  VAR f : boolean; 
BEGIN 
  assign (_file,_name); 
  {$I-} 
  reset (_file); 
  f := (ioresult = 0); 
  {$I+} 
  IF f THEN 
    close (_file); 
  search := f; 
END; (*** of search_file ***) 

PROCEDURE init (VAR tmp : count); 
  VAR c : char; 
BEGIN 
  FOR c := ' ' TO '~' DO 
    tmp [c] := 0; 
END; 

BEGIN 
  write ('Dateiname: '): 
  readln (filename); 
  found := search (infile,filename); 
  IF NOT found THEN 
    writeln ('Datei nicht gefunden!') 
  ELSE 
  BEGIN 
    init (letter); 
    assign (infile,filename); 
    reset (infile); 
    WHILE NOT eof (infile) DO 
    BEGIN 
      read (infile,c); 
      CASE c OF 
        #0..#31,#64       : index := '@'; 
        ' '..'?','A'..'~' : index := c; 
      END; 
      letter [index] := succ (letter [index]); 
    END; 
    close (infile); 
    FOR c := ' ' TO '~' DO 
      writeln (c,': ',letter [c]); 
  END; 
END. 
