(* Mit Kanonen auf PI
 *
 * Ein ungewhnliches Programm, das vielleicht mehr didaktischen als Alltagsnutzen 
 * aufweist, ist das folgende. Es soll nmlich die Kreiszahl PI (3.14159...) auf 
 * eine unkonventionelle Methode nherungsweise ermittelt werden. Da die Zahl c 
 * das Verhltnis zwischen Kreisumfang und Kreisdurchmesser darstellt, wird folgende 
 * Szene vorausgesetzt: Ein kreisrunder See, der von einem Quadrat umschlossen ist, 
 * das als Kantenlnge gerade den Kreisdurchmesser besitzt, wird von einer Kanone mit 
 * Kugeln beschossen. Man zhlt die abgeschossenen Kugeln und die Treffer, die im See 
 * landen. Ihr Verhltnis ergibt, wenn man nur oft genug schiet, auf statistischem 
 * Wege nherungsweise die Zahl PI. Da man das Verfahren vereinfachen mchte, benutzt 
 * man nur ein Viertel des Kreises bzw. des umschlieenden Quadrats, und multipliziert
 * das Ergebnis nachher mit 4. Ein Treffer im See findet dann statt, wenn der Abstand 
 * des Einschlags vom Kreismittelpunkt kleiner oder gleich 1 (das ist der Radius des 
 * Einheitskreises) ist. Die Kanone ist ein Zufallszahlengenerator, der die Koordinaten 
 * der Aufschlagpunkte berechnet (Zahlen zwischen 0 und 1). 
 *
 * Die Programmidee stammt aus "SPEKTRUM der Wissenschaft", Heft 6/85, 
 * das Programm stammt von mir. 
 *)


(*** Dieses Programm soll die Zahl PI mit der Kanonen-Methode ***) 
(*** aus SPEKTRUM 6/85 mglichst genau annhern.              ***) 
(*** (c) 1985/89/2001 by Claus Schnleber, KIEL                    ***) 

PROGRAM pint; 
  VAR shots,hits,count,max_shot,count_max : integer; 
      coord_x,coord_y,distance,pi         : real; 

PROCEDURE get_data; 
BEGIN 
  write ('Wieviele Schsse: '); 
  readln (max_shot); 
  write ('Wieviele Serien : '); 
  readln (count_max) 
END; (* of get_data *) 

PROCEDURE runtime; 
BEGIN 
  coord_x := 0; 
  coord_y := 0; 
  distance := 0; 
  pi := 0; 
  writeln; 
  writeln ('Das Schieen beginnt...'); 
  gotoxy (3,7); 
  write ('Treffer: '); 
  gotoXY (3,9); 
  write ('Serie : '); 
  FOR count := 1 TO count_max DO 
  BEGIN 
    gotoxy (13,9); 
    write (count:5); 
    hits := 0; 
    FOR shots := 1 TO max_shot DO 
    BEGIN 
      gotoxy (13,7); 
      write (hits:5); 
      coord_x := random; 
      coord_y := random; 
      distance := sqrt ((coord_x * coord_x) + (coord_y * coord_y)); 
      IF (distance <= 1) THEN 
        hits := hits + 1 
    END; 
    pi := (hits / shots * 4); 
    writeln; 
    writeln; 
    gotoxy (1,11 + count); 
    write ('PI ist ungefhr ',pi:1:7,' !!') 
  END; 
END; (* of runtime *) 

(*** MAIN ***) 

BEGIN 
  clrscr; 
  get_data; 
  runtime 
END. 
