(* Sortieren eines Feldes 
 *
 * Sortieren gehrt zu den wichtigsten Aufgaben in der EDV. Sobald es um die Verwaltung 
 * von Daten geht, mu der Datenbestand sortiert werden, um einen schnellen und sicheren 
 * Zugriff zu gewhrleisten. Sortiermethoden gibt es sehr viele. Wir wollen an dieser 
 * Stelle das Thema nur prinzipiell besprechen. Wenn Sie sich fr die verschiedenen 
 * Methoden interessieren, sei auf die Literatur verwiesen. Im nachfolgenden Programm 
 * werden in ein zehnelementiges Feld Zufallszahlen eingegeben, das danach sortiert und 
 * dann ausgegeben wird. Der Algorithmus selber kann in jedem beliebigen Programm verwendet
 * werden. In Band 2 wird es einige Anwendungen geben. 
 *
 * Einige erklrende Worte zum Verfahren, das auch Paartausch genannt wird. Sehen wir uns 
 * dazu ein Beispiel an: 
 * 
 *      5 3 17 2 
 * 
 * Man geht die Liste durch, indem man immer ein Element mit seinem unmittelbaren Nachbarn 
 * vergleicht. Sind die beiden nicht in der gewnschten Reihenfolge, so werden Sie einfach 
 * getauscht. Ist man am Ende der Liste und es ist getauscht worden, so geht man das
 * Verfahren solange wieder durch, bis bei einem Durchgang nicht mehr getauscht wurde. 
 * Dann ist der Vorgang zu Ende. Dabei darf man im Programm nur bis zum vorletzten Element 
 * gehen, denn da man immer auch den Nachfolger ansprechen mu, wrde ein Fehler auftreten,
 * wenn man das mit dem letzten Element machte; dieses Element hat ja keinen Nachfolger. 
 * Machen wir das Beispiel zu Ende ("*" bedeutet getauscht, "-" bedeutet nicht getauscht): 
 * 
 *      3 5 2 17 * 
 *      3 2 5 17 * 
 *      2 3 5 17 * 
 *      2 3 5 17 - 
 * 
 * Die Tatsache, ob getauscht worden ist oder nicht, wird im Flag "swapped" gespeichert. 
 *)

PROGRAM sort; 

  VAR data    : ARRAY [1..10] OF integer; 
      swapped : boolean; 
      i       : integer; 

PROCEDURE swap (VAR x,y : integer); 
  VAR dummy : integer; 
BEGIN 
  dummy := x; 
  x := y; 
  y := dummy; 
END; 

BEGIN 
  (***Initialisierung des Feldes durch Belegung ***) 
  (*** mit Zufallszahlen ***) 
    FOR i := 1 TO 10 DO 
    BEGIN 
      data [i] := random (100); 
      writeln (data [i]); 
    END; 
  (*** Sortieralgorithmus Bubblesort ***) 
    REPEAT 
      swapped := false; (* Flag initialisieren *) 
      FOR i := TO 9 DO 
      BEGIN 
        IF data [i] > data [i + 1] THEN 
        BEGIN 
          swap (data [i],data [i + 1]); 
          swapped := true; 
        END; 
      END; 
    UNTIL NOT swapped; 

  (*** Ausgabe des sortierten Feldes ***) 
    FOR i := 1 TO 10 DO 
      writeln (data [i]); 
END. 
